; script-fu-words-to-shapes Rel 13 Created by Tin Tran. Comments directed to http://gimpchat.com/viewtopic.php?f=9&t=14516 or http://gimpscripts.com
; License: GPLv3. This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
; This program is distributed in the hope that it will be useful, ; but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
; FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. http://www.gnu.org/licenses/gpl.html
; ------------ Change Log														Rel 6; added Tombstone shape. Rel 7; added Icecream cone shape.
; Rel 1: Changed from words-to-circles script over to words to house script.	Rel 8; fixed copy-paste bug that produced a square image 
; Rel 2: Fixed calculations so that shapes/text are centered.					Rel 9; added Stop sign shape. Rel 10; added Heart shape
; Rel 3: Resize image (width) if shapes are outside of boundaries				Rel 11; fixed Heart shape calculation bug.
; Rel 4: If user select -1 as radius we fit shapes to active layer's width.		Rel 12; 716 lines with Graechan's code 2016 to have shape transparency.
; Rel 5; insert shapes layers just above active layer instead of on top.		Rel 13; 147 lines by AlSchemist 2021: text: +color shape: +gradient +texture
(define (shape-xach-effect image drawable hl-offsetX hl-offsetY mode hl-color grad texur hl-opac ds-color ds-opac ds-blur ds-offsetX ds-offsetY isKeepSelect?)
	(define (fill-bck layer color) (gimp-context-set-background color) (gimp-edit-fill layer BACKGROUND-FILL))
	(let*	(	(ds-blur (max ds-blur 0)) (ds-opac (min ds-opac 100)) (ds-opac (max ds-opac 0)) (type (car (gimp-drawable-type-with-alpha drawable)))
				(image-width (car (gimp-image-width image))) (image-height (car (gimp-image-height image)))
			)
		(gimp-context-set-defaults) (gimp-layer-add-alpha drawable)
		(if (= (car (gimp-selection-is-empty image)) TRUE) (gimp-image-select-item image CHANNEL-OP-REPLACE drawable))
		(let*	(	(active-selection (car (gimp-selection-save image)))
					(hl-layer (car (gimp-layer-new image image-width image-height type _"Highlight" 100 NORMAL-MODE)))
				)
			(define (insert-layer-select layer) (gimp-image-insert-layer image layer 0 -1) (gimp-selection-none image) (gimp-edit-clear layer)
				(gimp-image-select-item image CHANNEL-OP-REPLACE active-selection)
			)
			(insert-layer-select hl-layer)
			(case mode	((0)(fill-bck hl-layer hl-color))		; background of the shape
						((1)(gimp-context-set-gradient grad)	; gradiant
							(gimp-edit-blend drawable BLEND-CUSTOM LAYER-MODE-NORMAL-LEGACY 0 hl-opac 20 REPEAT-NONE FALSE 0 0 0 0 0 0 image-width image-height)
						)
						((2)(gimp-context-set-pattern texur)(gimp-edit-bucket-fill drawable BUCKET-FILL-PATTERN LAYER-MODE-NORMAL-LEGACY hl-opac 255 FALSE 0 0))
			)
			(gimp-selection-translate image hl-offsetX hl-offsetY) (gimp-edit-fill hl-layer BACKGROUND-FILL) (gimp-selection-none image) ; border of the shape
			(gimp-image-select-item image CHANNEL-OP-REPLACE active-selection)
			(let*	((mask (car (gimp-layer-create-mask hl-layer ADD-WHITE-MASK)))) (gimp-layer-add-mask hl-layer mask) (fill-bck mask (list hl-opac hl-opac hl-opac)))
			(let*	((shadow-layer (car (gimp-layer-new image image-width image-height type _"Shadow" ds-opac NORMAL-MODE))))
				(insert-layer-select shadow-layer) (gimp-selection-translate image ds-offsetX ds-offsetY)
				(fill-bck shadow-layer ds-color) (gimp-selection-none image) ; shadow of the shape
				(plug-in-gauss-rle RUN-NONINTERACTIVE image shadow-layer ds-blur TRUE TRUE)
				(gimp-image-select-item image CHANNEL-OP-REPLACE active-selection) (gimp-edit-clear shadow-layer) (gimp-image-lower-item image shadow-layer)
			)
			(if (not isKeepSelect?) (gimp-selection-none image))
			(gimp-image-merge-down image (car (gimp-image-merge-down image hl-layer EXPAND-AS-NECESSARY)) EXPAND-AS-NECESSARY) ;Graechan
			(gimp-image-remove-channel image active-selection)
)	)	)
(define	(gen-shape image layer word font coTxt ctrx ctry rad mode coShap grad texur hl-opac-comp isDrawShape? shapeType)
	(let*	(	(width (car (gimp-image-width image)))	(height (car (gimp-image-height image)))
				(word-length (string-length word))(lenTxt7 (* word-length 7))
				(charList (map (lambda (x) (make-string 1 x)) (string->list word))) ;create the list of letters as string
				(word-width	(let loop	((lstChar charList) (sum-width 0)) 
								(if (not (pair? lstChar)) sum-width 
									(let*	((layerWord (car (gimp-text-layer-new image (car lstChar) font 200 0))) (widthWrd (car (gimp-drawable-width layerWord))))
										(loop (cdr lstChar)(+ sum-width (and (gimp-item-delete layerWord) widthWrd)))
				)			)	)	) ; must i manually create all letters individually and add them up...don't know but this is the work around for now
				(rad2 (* rad 2)) (rad/2 (/ rad 2)) (radx (+ ctrx rad)) (rady (+ ctry rad)) (x-rad (- ctrx rad)) (y-rad (- ctry rad))
				(bw-layer (car (gimp-layer-new image width height RGBA-IMAGE word 100 NORMAL-MODE)) layerPrev)
				(space-width (/ rad2 (+ lenTxt7 2))) (stopDiv (* 5 (/ rad2 24.14213562)))	(heart-offset (* 0.7071067812 rad/2)) ;diamond
				(v10 (vector ctrx y-rad radx ctry radx rady x-rad rady x-rad ctry))
			)
		(define	(write-word-in-shape)
			(define (circle-top-pt x a) ; Calculate circle points on top of heart. y distance and x1 for point on circumference
				(if (or (<=	x (- rad/2 heart-offset)) (>= x (- rad2 (- rad/2 heart-offset)))) (- a rad/2)
					(*	(- (- rad (abs(- rad x))) (- rad/2 heart-offset)) (/ (+ rad (- rad/2 heart-offset)) (+ rad/2 heart-offset))
			)	)	)
			(define (transf isRnd? layer x0 y0 x1 y1 x2 y2 x3 y3) (define (rd x) (if isRnd? (round x) x))
				(gimp-item-transform-perspective layer (rd x0) (rd y0) (rd x1) (rd y1) (rd x2) (rd y2) (rd x3) (rd y3))
			)
			(gimp-context-set-foreground coTxt) (gimp-selection-none image)
			(let loop	((lstChar charList) (x1 space-width)) ;calculate y distance to combine with x1 to get point on circumference
				(if (pair? lstChar)
					(let*	(	(layerWrd (car (gimp-text-layer-new image (car lstChar) font 200 0)))
								(char-width (* (/ (* (/ (car (gimp-drawable-width layerWrd)) word-width) lenTxt7) (+ lenTxt7 2)) rad2)) (x2 (+ x1 char-width))
							)	; circle: 0, house: 1, tombstone: 2, ice cream cone: 3, stop sign: 4, heart: 5
						(gimp-image-insert-layer image layerWrd 0 -1)
						(case shapeType ((1 2) (define (hot x)(if (= shapeType 1) (abs (- rad (abs (- rad x)))) (sqrt (- (pow rad 2) (pow (abs (- rad x)) 2)))))
							(let* ((b1 (hot x1)) (b2 (hot x2))) (transf #t layerWrd (+ x-rad x1)(- ctry b1)(+ x-rad x2)(- ctry b2)(+ x-rad x1) rady (+ x-rad x2) rady))
						)				); (ho)use and (t)ombstone
						(case shapeType ; Calculate y distance combined with x2 to get point on circumference
							((0)(let*	(	(b1 (and (define (circle x)(sqrt (- (pow rad 2) (pow (abs (- rad x)) 2)))) (circle x1)))	(b2 (circle x2)))
									(transf #t layerWrd	(+ x-rad x1) (- ctry b1) (+ x-rad x2) (- ctry b2) (+ x-rad x1) (+ ctry b1)	(+ x-rad x2) (+ ctry b2))
							)	)
							((3)(let*	(	(a1 (and (define (cone x)(sqrt (- (pow rad 2) (pow (abs (- rad x)) 2)))) (cone x1))) (a2 (cone x2))
											(b1 (and (define (triangle x)(abs (- rad (abs (- rad x))))) (triangle x1))) (b2 (triangle x2)) ; triangle points b1 and b2
										) ; calculate y distance combined with x1 to get point on circumference. y distance with x2 to get point on circumference
									(transf #f layerWrd (+ x-rad x1)(- ctry a1) (+ x-rad x2)(- ctry a2) (+ x-rad x1)(+ ctry (* b1 2)) (+ x-rad x2)(+ ctry (* b2 2)))
							)	)	; ice cream cone; calculate circle points a1 and a2
							((4)(let*	(	(b1 (and (define (stopsign x)(min rad (+ (abs (- rad (abs (- rad x)))) stopDiv))) (stopsign x1))) (b2 (stopsign x2)))
									(transf #f layerWrd (+ x-rad x1) (- ctry b1) (+ x-rad x2) (- ctry b2) (+ x-rad x1) (+ ctry b1) (+ x-rad x2) (+ ctry b2))
							)	)
							((5)(let*	(	(a1	(and (define (heart x)(sqrt (- (pow rad/2 2) (pow (abs(if (<= x rad) (- rad/2 x) (- (* rad/2 3) x))) 2))))(heart x1)))
											(a2	(heart x2)) (b1	(circle-top-pt x1 a1)) (b2	(circle-top-pt x2 a2)) ;calculate points on bottom of heart
										)	(transf #f layerWrd	(+ x-rad x1) (- ctry rad/2 a1) (+ x-rad x2) (- ctry rad/2 a2) 
																(+ x-rad x1) (+ (- ctry (- rad/2 heart-offset)) b1) (+ x-rad x2) (+ (- ctry (- rad/2 heart-offset)) b2)
						)	)	)			) 
						(loop (cdr lstChar) (and (gimp-image-merge-down image layerWrd EXPAND-AS-NECESSARY) x2)) ; x1 now takes position of x2
			)	)	)
			(gimp-displays-flush)
		)
		(gimp-image-insert-layer image bw-layer 0 -1)
		(and isDrawShape? (gimp-context-set-foreground coShap) (case shapeType ((0 2 3)(gimp-image-select-ellipse image CHANNEL-OP-REPLACE x-rad y-rad rad2 rad2)))
			(case shapeType ((1 2)	(gimp-image-select-polygon image (if (= shapeType 1) CHANNEL-OP-REPLACE CHANNEL-OP-ADD) 10 v10)))
			(case shapeType ((2)(gimp-image-select-polygon image CHANNEL-OP-ADD 10 v10))
				((3)(gimp-image-select-polygon image CHANNEL-OP-SUBTRACT 8 (vector (- x-rad 1) ctry (+ radx 1) ctry (+ radx 1) rady (- x-rad 1) rady))
					(gimp-image-select-polygon image CHANNEL-OP-ADD 6 (vector x-rad ctry radx ctry ctrx (+ ctry rad2))) ; - lower rect/2 + triangle
				)
				((4)(gimp-image-select-polygon image CHANNEL-OP-REPLACE 16
						(vector	(- ctrx stopDiv) y-rad (+ ctrx stopDiv) y-rad radx (- ctry stopDiv) radx  (+ ctry stopDiv)
								(+ ctrx stopDiv) rady  (- ctrx stopDiv) rady x-rad (+ ctry stopDiv) x-rad (- ctry stopDiv)
				)	)	)
				((5)(gimp-image-select-ellipse image CHANNEL-OP-REPLACE x-rad y-rad rad rad) ;circle1
					(gimp-image-select-ellipse image CHANNEL-OP-ADD		ctrx  y-rad rad rad) ;circle2
					(gimp-image-select-polygon image CHANNEL-OP-ADD 10
						(vector (- ctrx rad/2 heart-offset) (+ (- ctry rad/2) heart-offset) (- ctrx rad/2) (- ctry rad/2) (+ ctrx rad/2)
								(- ctry rad/2) (+ ctrx rad/2 heart-offset) (+ (- ctry rad/2) heart-offset) ctrx (+ ctry rad)
			)	)	)	)
			(shape-xach-effect image bw-layer -1 -1 mode coShap grad texur hl-opac-comp "black" 100 12 5 5 #f)
			(gimp-item-set-name (car (gimp-image-get-active-layer image)) word)
		)
		(write-word-in-shape)
)	)
(define (script-fu-words-to-shapes image layer text font coTxt ctrx ctry rad mode coShap grad texur hl-opac toggleDrawShape shapeType)
	(let*	(	(width  (if (= rad -1) (car (gimp-drawable-width layer))  (car (gimp-image-width image ))))
				(height (if (= rad -1) (car (gimp-drawable-height layer)) (car (gimp-image-height image))))
				(ctrx   (if (= ctrx -1) (/ width 2) ctrx)) (ctry (if (= ctry -1) (/ height 2) ctry))
				(words	(strbreakup text " ")) (wordcount (length words)) (isDrawShape? (= toggleDrawShape TRUE))
				(rad    (if (= rad -1) (/(*(/ width (+(* wordcount 7) (+ wordcount 1))) 7)2) rad))
				(wordwidth (* rad 2)) (spacewidth (/ wordwidth 7)) (large-rad (/ (+ (* wordwidth wordcount) (* spacewidth (+ wordcount 1))) 2))
				(minx (if (< ctrx large-rad) (- ctrx large-rad) 0)) (maxx (if (> (+ ctrx large-rad) width) (+ ctrx large-rad) width))
			)	; if rad -1 we'll try to fit it so that shapes all fit within width assuming -1 was selected for ctrx as well
		(gimp-context-push) (gimp-image-undo-group-start image) (gimp-image-resize image (abs(- maxx minx)) height (- minx) 0)	
		(let loop ((words words)(idx (- ctrx large-rad minx)) (layerShape 0))
			(if (pair? words)
				(let*	((word (car words))	(sumx (+ idx spacewidth rad)))
					(loop (cdr words)(+ sumx rad)(gen-shape image layer word font coTxt sumx ctry rad mode coShap grad texur hl-opac isDrawShape? shapeType))
		)	)	)
		(gimp-image-undo-group-end image) (gimp-context-pop) ;undo group in one step
)	) ;              function name                last menu			description																	author name
(script-fu-register "script-fu-words-to-shapes" "_Words to shapes" "Words to shapes 2.0 Creates word(s) that fits inside a house(s)/circle(s)" "Tin Tran"
"2016, Tin Tran. 2021, AlSchemist" "2021" "RGB*, GRAY*" 	;copyright info or description, date, mode
SF-IMAGE "Image" 0														SF-DRAWABLE   "Layer" 0	SF-STRING				"Words" "Gimp Chat Dot Com"
SF-FONT       "Font"          "Sans Bold"								SF-COLOR      "Color of text"					'(0 0 0)
SF-ADJUSTMENT "Center X (-1 = Image X Center)"   '(-1 -1 2000 1 10 1 0)	SF-ADJUSTMENT "Center Y (-1 = Image Y Center)"	'(-1 -1 2000 1 10 1 0)
SF-ADJUSTMENT "Radius/Width (-1 = Fit to Width)" '(-1 -1 2000 1 10 1 0)	
SF-OPTION      "Mode"            '(_"COLOR" _"GRADIENT" _"TEXTURE")		SF-COLOR      "Background color of shape"		'(255 0 0)		
SF-GRADIENT    "Gradient"        "Pastel Rainbow"						SF-PATTERN	  "Texture"	"Marble #1"
SF-ADJUSTMENT _"Highlight opacity"       '(100 0 255 1 10 0 0)  ;Graechan
SF-TOGGLE     "Draw background shape"     TRUE							SF-OPTION "Shape Type" '("Circle" "House" "Tombstone" "Ice Cream Cone" "Stop Sign" "Heart")
)(script-fu-menu-register "script-fu-words-to-shapes" "<Image>/Filters/Render/")